%clear all;

disp(' ');
disp('---------------------------------------');
disp('Fixed point 14 bit  Inf. Filter with DF');
disp('---------------------------------------');

mur=1;
ur=zeros(mur,1); u0r=zeros(mur,1); uxr=zeros(mur,1);
rr=eye(mur);

u0r=0.0;
cfr=0.08;

knr=zeros(mur,1);  [knr,mur,tmp1,tmp2]=infi(knr,mur,1,0);
xnr=zeros(mur,1);  [xnr,mur,tmp1,tmp2]=infi(xnr,mur,103,2);
xnpr=zeros(mur,1); [xnpr,mur,tmp1,tmp2]=infi(xnpr,mur,0,0);

mys=1; mus=1;
ipss=23; yips=2;
ys=zeros(mys,1); us=zeros(mus,1);es=zeros(mys,1);
kns=zeros(mys,1);  [kns,mys,tmp1,tmp2]=infi(kns,mys,1,0);
xns=zeros(mys,1);  [xns,mys,ipss,yips]=infi(xns,mys,ipss,yips);
xnps=zeros(mys,1); [xnps,mys,tmp1,tmp2]=infi(xnps,mys,0,0);

lus=3+20; lys=0; les=1;
nus=0;
kpys=0; iups=0; kpus=0; ieps=0; kpes=0; izs=0; iers=0;
iyps=mys*lys; kpys=iyps-mys;
ipss=mus*lus;
iups=mus*nus+ipss; kpus=iups-mus;
ieps=mys*les;      kpes=ieps-mys;
izs=iyps+ipss+ieps+1;
sd03_i = [mys,mus,iyps,kpys,iups,kpus,ieps,kpes,nus,izs];
if iyps> 0 yps=zeros(iyps,1); else yps=0; end
if iups> 0 ups=zeros(iups,1); else ups=0; end
if ieps> 0 eps=zeros(ieps,1); else eps=0; end
zs=zeros(izs,1); zs(izs,1)=1.0;
b0ps=0.1; bps=0.9; aps=0.98; c0ps=0.02; cps=0.0;
ps=zeros(mys,izs);

[ps,mys,mus,lus,lys,les,izs,b0ps,bps,aps,c0ps,cps,iers]=...
    mkin(ps,mys,mus,lus,lys,les,izs,b0ps,bps,aps,c0ps,cps,iers);

ps(1,1)=.11; ps(1,2)=.09; ps(1,3)=.1; ps(1,4+20)=.005; ps(1,5+20)= 0;

nbp=8;mps=5+20;
jts=[1     200  280  360  1200  1280   1360  1500];
pns=[.11   .11  .16  .11  .11   .16    .11    .11 ;
    .09   .09  .04  .09  .09   .04    .09    .09 ;
    .1    .1   .1   .1   .1    .1     .1     .1 ;
    .0    .0   .0   .0   .0    .0     .0     .0 ; 
    .0    .0   .0   .0   .0    .0     .0     .0 ;
    .0    .0   .0   .0   .0    .0     .0     .0 ;
    .0    .0   .0   .0   .0    .0     .0     .0 ;
    .0    .0   .0   .0   .0    .0     .0     .0 ;
    .0    .0   .0   .0   .0    .0     .0     .0 ;
    .0    .0   .0   .0   .0    .0     .0     .0 ;
    .0    .0   .0   .0   .0    .0     .0     .0 ;
    .0    .0   .0   .0   .0    .0     .0     .0 ;
    .0    .0   .0   .0   .0    .0     .0     .0 ;
    .0    .0   .0   .0   .0    .0     .0     .0 ;
    .0    .0   .0   .0   .0    .0     .0     .0 ;
    .0    .0   .0   .0   .0    .0     .0     .0 ;
    .0    .0   .0   .0   .0    .0     .0     .0 ;
    .0    .0   .0   .0   .0    .0     .0     .0 ;
    .0    .0   .0   .0   .0    .0     .0     .0 ;
    .0    .0   .0   .0   .0    .0     .0     .0 ;
    .0    .0   .0   .0   .0    .0     .0     .0 ;
    .0    .0   .0   .0   .0    .0     .0     .0 ;
    .0    .0   .0   .0   .0    .0     .0     .0 ;
    .005  .005 .005 .005 .005  .005   .005   .005;
    .0    .0   .0   .0   .0    .0     .0     .0  ];
jtw=1;
srw=zeros(mps,jtw);

mum=1; mym=1; mvm=1; im=0;
um=zeros(mum,1); ym=zeros(mym,1); vm=zeros(mvm,1); wm=0;

lum=3+20; lym=0; lvm=0; lem=0; l1m=0; num=0;
ksm=0;
if ksm == 1
    if lum-lym-1 ~= 0
        disp('error: you have to set lum = lym+1 for ksm ==1');
    end
end
kum=0; kym=0; kvm=0; kem=0; kim=0;

kfm=0; %md51,md84

kpm=1; kpim=1; knm=0;

izum=mum*(lum+num); jum=izum-mum;
izym=mym*(lym+1);   jym=izym-1;
izvm=mvm*(lvm);     jvm=izvm-mvm;
izem=mym*lem;       jem=izem-1;
idm=izum+izym+izvm+izem-(mum*num)+l1m;

ilm=idm*(idm-1)/2; %md51, md83

fim=0.8; fam=0.8; f0m=0.001;

fiim = 16384*fim;   %md83, md84
f0im = 16384*f0m; faim = 16384*fam; %md84

dfm=3.0;
dfdm=1; dfim=0; edim=0;
[dfdm,dfm,dfim,edim]=flno(dfdm,dfm,dfim,edim);

md84_i = [mum,mym,mvm,izum,jum,izym,jym,izvm, ...
    jvm,izem,jem,lum,lym,lvm,lem,num, ...
    ksm,kum,kym,kvm,kem,idm,ilm,kpm,kpim,knm,kfm, ...
    dfim,edim,fiim,f0im,faim];

udm=zeros(mum,1); ydm=zeros(mym,1);vdm=zeros(mvm,1);edm=zeros(mym,1);
zym=zeros(izym,1);
if izum > 0 zum=zeros(izum,1); else zum=0; end
if izvm > 0 zvm=zeros(izvm,1); else zvm=0; end
if izem > 0 zem=zeros(izem,1); else zem=0; end

dm=zeros(idm,1); dm(idm,1)=l1m;
dim=zeros(idm,1); dcm=zeros(idm,1); admm=1.0*ones(idm,1); kadm=12*ones(idm,1);

md84_d=[dm, dim, dcm, admm, kadm];

pm=zeros(idm,1);

in_diag=1e-3;

lzm=in_diag*ones(idm,1); %md73

penm=zeros(idm,idm);  %md73
pesm=zeros(idm,idm);  %md73
lzsm=zeros(idm,1);    %md73
llsm=zeros(idm,idm);  %md73
alsm=zeros(idm,1);    %md73
fnfm=zeros(idm,1); fsfm=zeros(idm,1); zdm=zeros(idm,1);

ex2m =[.0625, .125, .25, .5, 1, 2, 4, 8, 16, 32];
ex4m =[.390625e-02, .15625e-01, .625e-01, .25, 1, 4, 16, 64, 256, 1024];

pnim=zeros(ilm,1); psim=zeros(ilm,1); enim=zeros(ilm,1); esim=zeros(ilm,1);

fnim=zeros(idm,1); fsim=zeros(idm,1); zdim=zeros(idm,1); znim=zeros(idm,1);
asim=zeros(idm,1); lzim=zeros(idm,1); lsim=zeros(idm,1); elim=zeros(idm,1);
gaim=zeros(idm,1); dlim=zeros(idm,1); zsim=zeros(idm,1);

[idm,lzm,lzim,elim]=flno(idm,lzm,lzim,elim);

md84_dil= [pnim, psim, enim, esim];
md84_did= [fnim, fsim, zdim, znim, asim, lzim, lsim, elim, gaim, dlim, zsim];

md84_iil= [pnim, psim, enim, esim];
md84_iid= [fnim, fsim, zdim, znim, asim, lzim, lsim, elim, gaim, dlim, zsim];

rm=0; em=0; efm=0;
% zerm=1.0e-6; dzm=0; %md51
zerm=1.0e-6; %md84

u=ur; y=ys;

N=1500; i=1; ip=1; in=150;
i_loop=1;comp_t=0;

xx  = zeros(N,1);

yy1 = zeros(N,1);
yy2 = zeros(N,1);
yy3 = zeros(N,1);
yy4 = zeros(N,1);
yy5 = zeros(N,1);
yy6 = zeros(N,1);

tic;
for i=1:N,
    [u,mur,u0r,uxr,rr,cfr,knr,xnr,xnpr]=...
        r03 (u,mur,u0r,uxr,rr,cfr,knr,xnr,xnpr);
    [i,jts,pns,jtw,srw,mps,nbp,ps]=...
        md81(i,jts,pns,jtw,srw,mps,nbp,ps);
    [y,u,es,xns,xnps,yps,ups,eps,ps,kns,zs,sd03_i]=...
        sd03(y,u,es,xns,xnps,yps,ups,eps,ps,kns,zs,sd03_i);
    [u,y,vm,em,efm,udm,ydm,vdm,edm,zum,zym,zvm,zem,pm,rm,dfm,fim,penm,lzm,pesm,lzsm,llsm,alsm,fnfm,fsfm,ex2m,ex4m,zerm,md84_iil,md84_dil,md84_iid,md84_did,md84_i,md84_d]=...
        md84(u,y,vm,em,efm,udm,ydm,vdm,edm,zum,zym,zvm,zem,pm,rm,dfm,fim,penm,lzm,pesm,lzsm,llsm,alsm,fnfm,fsfm,ex2m,ex4m,zerm,md84_iil,md84_dil,md84_iid,md84_did,md84_i,md84_d);
    
    xx(i)=i;
    yy1(i)=ps(1);
    yy2(i)=pm(1);
    yy3(i)=ps(2);
    yy4(i)=pm(2);
    yy5(i)=efm;
    yy6(i)=u;
end; 	           % please wait..

comp_t=toc;
disp(['The Loop Computated in ',num2str(comp_t),' seconds']);

hold on;
axis([1 N -0.05 0.2]);

plot_clr=['c'];
plot(xx,yy1,'m',      ...
    xx,yy2,plot_clr, ...
    xx,yy3,'m',      ...
    xx,yy4,plot_clr, ...
    xx,yy5,plot_clr,...
    xx,0.175+0.025*yy6,'m', 'LineWidth', 2);

set(gca,'fontsize', 10)

save lf_84i yy2 yy4 yy5;
%save('time', 'comp_t');

